/******************************************************************************
    Copyright (c) 2007 Electronic Tools Company    ALL RIGHTS RESERVED

  The contents of this file are subject to the restrictions and limitations
  set forth in the SYNOPSYS Open Source License Version 1.0  (the "License"); 
  you may not use this file except in compliance with such restrictions 
  and limitations. You may obtain instructions on how to receive a copy of 
  the License at

  http://www.synopsys.com/partners/tapin/open_source/license_liberty.html. 

  Software distributed by Original Contributor under the License is 
  distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either 
  expressed or implied. See the License for the specific language governing 
  rights and limitations under the License.

******************************************************************************/

#ifndef _ENTRY_H__
#define _ENTRY_H__
#include "si2dr_liberty.h"
#include "stdc++.h"

class Entry;

class Entry
{
  int nStartLine;
public:
  Entry(int lineno){nStartLine = lineno;}
  virtual ~Entry() {}

  int start_lineno() { return nStartLine; }

  virtual void read(si2drGroupIdT, char *){} 
  virtual int Read(ifstream&){return 0;} 
  virtual void WriteTo(ostream&, const string&) {} 
  virtual void addVectors() {}
  virtual void addGoodDelay() {}
  virtual void addGoodSlew() {}
  virtual void addIgnoreDelay() {}
  virtual void addIgnoreSlew() {}
  virtual int getVectors() { return 1;}
  virtual int getGoodDelay() { return 0;}
  virtual int GetGoodSlew() {return 0;}
  virtual int GetIgnoreDelay() {return 0;}
  virtual int GetIgnoreSlew() {return 0;}
  virtual string name() const { return "";}
  virtual string value() const { return "";}
  virtual string type() const { return "";}

  virtual void addAttr(const string&, size_t) {}
  virtual size_t findAttr(const string&) const {return 0;}

  virtual Entry* findSubgroup(const string&) const{return 0;}
  virtual Entry* findSubgroup(const string&, const string&) const{return 0;}

  virtual void addTemplate(const string&, size_t) {}
  virtual Entry* findTemplate(const string&) const {return 0;}
  virtual void searchTemplates(map <string, int>&) const {}

  virtual void addCell(const string&, size_t){}

  virtual void addValue(const string&, size_t) {}

  virtual double getReferenceTime() {return 0;}
  virtual int getReferenceTime_precision() {return 0;}
  virtual void getIndexes(vector < vector<double> >& ) {}
  virtual void getIndexes_precision(vector < int >&) {}
  virtual void getData(vector < double >&) {}
  virtual int getData_precision() {return 0;}
  virtual int findVarIndex(const string&) const {return 0;}

  virtual string key() const { return "Entry";}
  virtual void Ccs2ecsm(const string&, const string&) {}
};

#endif
