/******************************************************************************
    Copyright (c) 2007 Electronic Tools Company    ALL RIGHTS RESERVED

  The contents of this file are subject to the restrictions and limitations
  set forth in the SYNOPSYS Open Source License Version 1.0  (the "License"); 
  you may not use this file except in compliance with such restrictions 
  and limitations. You may obtain instructions on how to receive a copy of 
  the License at

  http://www.synopsys.com/partners/tapin/open_source/license_liberty.html. 

  Software distributed by Original Contributor under the License is 
  distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either 
  expressed or implied. See the License for the specific language governing 
  rights and limitations under the License.

******************************************************************************/

#ifndef _GROUP_H__
#define _GROUP_H__

#include "entry.h"

enum Classtype {    
    eGroup = 0,
    eLibrary,
    eTemplate,
    eScaling_factor,
    eCell,
    ePin,
    ePath,
    eValue
};

class Template;

class Group : public Entry
{
  string strType;
  string strName;

  static map <string, Classtype> classtype;

  Group* Parent;
  map <string, size_t> attrs;

public:
  vector <Entry*> entries;

  Group(int, const string&, const string&, Group *p=NULL);
  ~Group();

  int Read(ifstream&);
  void read(si2drGroupIdT group, char *indent);
  void WriteTo(ostream&, const string&);
  virtual double getLibFactor() {return 1;}

  string type() const { return strType;}
  string name() const { return strName;}
  Group* parent() const { return Parent; }

  void name(const string& name) {strName = name;}

  void addAttr(const string&, size_t);
  size_t findAttr(const string&) const;

  Entry* findSubgroup(const string&) const;
  Entry* findSubgroup(const string&, const string&) const;

  Entry* findTemplate(const string&) const;
  void searchTemplates(map <string, int >&) const;

  Classtype getClasstype(const string&) const;

  void Ccs2ecsm(const string&, const string&);
  void removeSubgroup(const string&);

private:
  void init();

  virtual void AfterRead(){}
  virtual void writeContents(ostream&, const string&);

};

#endif
