/******************************************************************************
    Copyright (c) 2007 Electronic Tools Company    ALL RIGHTS RESERVED

  The contents of this file are subject to the restrictions and limitations
  set forth in the SYNOPSYS Open Source License Version 1.0  (the "License"); 
  you may not use this file except in compliance with such restrictions 
  and limitations. You may obtain instructions on how to receive a copy of 
  the License at

  http://www.synopsys.com/partners/tapin/open_source/license_liberty.html. 

  Software distributed by Original Contributor under the License is 
  distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either 
  expressed or implied. See the License for the specific language governing 
  rights and limitations under the License.

******************************************************************************/

#ifndef _LIBRARY_H__
#define _LIBRARY_H__

#include "group.h"
#include <time.h>

class Library;

class Library : public Group
{
  map <string, size_t> templates;
  map <string, size_t> cells;
  string libFileName;
  double factor;
  int nGoodDelay, nGoodSlew, nVectors, nIgnoreDelay, nIgnoreSlew;
public:
  Library(int lineno=1);
  ~Library();

  void addVectors() {nVectors++;}
  void addGoodDelay() {nGoodDelay++;}
  void addGoodSlew() {nGoodSlew++;}
  void addIgnoreDelay() {nIgnoreDelay++;}
  void addIgnoreSlew() {nIgnoreSlew++;}
  int getVectors() { return nVectors;}
  int getGoodDelay() {return nGoodDelay;}
  int getGoodSlew() {return nGoodSlew;}
  int getIgnoreDelay() {return nIgnoreDelay;}
  int getIgnoreSlew() {return nIgnoreSlew;}
  void OpenLibrary(const string&);
  void ReadLibrary(const string&);
  void setLibFileName(const string& str) { libFileName = str ;}
  string& getLibFileName() { return libFileName ;}
  double getLibFactor() { return factor; }
  void setLibFactor(double fact) { factor = fact; }
  void WriteLibrary(const string&, bool);

  void addTemplate(const string&, size_t);
  Entry* findTemplate(const string&) const;

  void addCell(const string&, size_t);

  void Split();
  void Sublib(const string&, const char* libname = "sub.lib");

  void Ccs2ecsm(const string&, const string&);
};

#endif
