/******************************************************************************
    Copyright (c) 2007 Electronic Tools Company    ALL RIGHTS RESERVED

  The contents of this file are subject to the restrictions and limitations
  set forth in the SYNOPSYS Open Source License Version 1.0  (the "License"); 
  you may not use this file except in compliance with such restrictions 
  and limitations. You may obtain instructions on how to receive a copy of 
  the License at

  http://www.synopsys.com/partners/tapin/open_source/license_liberty.html. 

  Software distributed by Original Contributor under the License is 
  distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either 
  expressed or implied. See the License for the specific language governing 
  rights and limitations under the License.

******************************************************************************/

#include "stdc++.h"

#include "myregex.h"

bool Regex::bInit = true;
Pattern_t Regex::pattern[eMAX_PAT] = {
    {"^\\s*([a-zA-Z][a-zA-Z0-9_]*)\\s*\\(\\s*(.*)\\s*\\)\\s*\\{", 2},// Group start
    {"^\\s*library\\s*\\(\\s*(.+)\\s*\\)\\s*\\{", 1}, // Library start
    {"^\\s*\\}", 0},                                  // Group end
    {"^\\s*([a-zA-Z][a-zA-Z0-9_]*)\\s*:\\s*(.+)\\s*;", 2},             // Attr 1
    {"^\\s*([a-zA-Z][a-zA-Z0-9_]*)\\s*\\((.+)\\)\\s*;",2},             // Attr 2
    {"^\\s*set\\s+([a-zA-Z][a-zA-Z0-9_]*)\\s+[=:]*\\s*(.*)\\s*", 2}           //Option 
};
regex_t* Regex::preg[eMAX_PAT];
 
Regex::Regex()
{
}

Regex::~Regex()
{
  for (int i=0; i<eMAX_PAT; i++) {
    regfree(preg[i]);
    delete preg[i];
  }
}

