/******************************************************************************
    Copyright (c) 2007 Electronic Tools Company    ALL RIGHTS RESERVED

  The contents of this file are subject to the restrictions and limitations
  set forth in the SYNOPSYS Open Source License Version 1.0  (the "License"); 
  you may not use this file except in compliance with such restrictions 
  and limitations. You may obtain instructions on how to receive a copy of 
  the License at

  http://www.synopsys.com/partners/tapin/open_source/license_liberty.html. 

  Software distributed by Original Contributor under the License is 
  distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either 
  expressed or implied. See the License for the specific language governing 
  rights and limitations under the License.

******************************************************************************/

#ifndef _VALUE_H__
#define _VALUE_H__

#include "group.h"
#include "attr.h"

class Value : public Group
{
  double m_dblRefTime;
  int m_dblRefTime_precision;
  vector < vector<double> > indexes;
  vector <double> m_dblData;
  vector < int> indexes_precision;
  int m_dblData_precision;

public:
  static int nGoodDelay, nGoodSlew, nVectors, nIgnoreDelay, nIgnoreSlew;

public:
  Value(int, const string&, const string&, Group *p);
  ~Value();

  void Ccs2ecsm(const string&, const string&);
  void searchTemplates(map <string, int>&) const;
  double getReferenceTime() { return m_dblRefTime; }
  int getReferenceTime_precision() { return m_dblRefTime_precision; }
  void getIndexes(vector < vector<double> > & rtn_indexes) { rtn_indexes= indexes; }
  void getIndexes_precision(vector < int > & rtn_indexes_p) { rtn_indexes_p= indexes_precision; }
  int getData_precision() { return m_dblData_precision; }
  void getData(vector <double>& rtn_m_dblData) { rtn_m_dblData= m_dblData; }

private:
  void AfterRead();
  void writeContents(ostream&, const string&);
  double interp_time(double, double, double, double, double, double, double);
  void add_ecsmwave(const string&, const int&, const int&);
  void interp_cap(Value*);
  std::vector<double> elimination(std::vector<std::vector<double> > a,
                                  std::vector<double> b);
};

#endif
